// reduction of Apple genericButton stuff
// now attempting augmentation for custom graphics on a per button basis...
// checking enhanced attribute syntax (JMS suggestion)

function createGenerikButton (div, title, onaction, notPressedLook, pressedLook)
{
	div.style.height = "25px";
	div.style.width = "25px";  // ... admittedly lame

	div.style.appleDashboardRegion = 'dashboard-region(control rectangle)';
	var element = document.createElement ('img');
	element.src = notPressedLook;
	div.appendChild (element);
	

	
	div.setAttribute ("generikButtonOnAction", onaction);

	div.setAttribute ("onmousedown", "generikButtonMouseDownHandler(event, this);");
	div.generikButtonEnabled = true;
	div.generikButtonInside = true;
	div.generikButtonAction = onaction;

// was pressedLook	
	div.notPressedButton = notPressedLook;
	div.pressedButton = pressedLook;

	// force the other image to load.
	var img = new Image;
	img.src = pressedLook;
}

function generikButtonSetEnabled (div, enabled)
{
//	var span = div.childNodes[1];
//	enabled = enabled ? true : false;
//	
//	if (enabled)
//		span.style.color = "white";
//	else
//		span.style.color = "rgb(150,150,150)";	
// I have no idea what this was, but there is no node at 1		
		
	div.generikButtonEnabled = enabled;
}

// do not call the following methods directly
var generikButtonCurrentMouseDownButton = null;
function generikButtonMouseDownHandler(event, div)
{
	if (div.generikButtonEnabled)
		div.childNodes[0].src = div.pressedButton;
	
	document.addEventListener("mousemove", generikButtonMouseMoveHandler, true);
	document.addEventListener("mouseup", generikButtonMouseUpHandler, true);
	div.addEventListener("mouseover", generikButtonMouseOverHandler, true);
	div.addEventListener("mouseout", generikButtonMouseOutHandler, true);
	
	div.generikButtonInside = true;
	generikButtonCurrentMouseDownButton = div;
	
	event.stopPropagation();
	event.preventDefault();

}

function generikButtonMouseMoveHandler (event)
{
	event.stopPropagation();
	event.preventDefault();
}

function generikButtonMouseOverHandler (event)
{
	if (generikButtonCurrentMouseDownButton && generikButtonCurrentMouseDownButton.generikButtonEnabled)
		generikButtonCurrentMouseDownButton.childNodes[0].src = generikButtonCurrentMouseDownButton.pressedButton;
			
	generikButtonCurrentMouseDownButton.generikButtonInside = true;

	event.stopPropagation();
	event.preventDefault();
}

function generikButtonMouseOutHandler (event)
{
	if (generikButtonCurrentMouseDownButton && generikButtonCurrentMouseDownButton.generikButtonEnabled)
		generikButtonCurrentMouseDownButton.childNodes[0].src = generikButtonCurrentMouseDownButton.notPressedButton;


	generikButtonCurrentMouseDownButton.generikButtonInside = false;
	
	event.stopPropagation();
	event.preventDefault();
}

function generikButtonMouseUpHandler (event)
{
	if (generikButtonCurrentMouseDownButton && generikButtonCurrentMouseDownButton.generikButtonEnabled)
		generikButtonCurrentMouseDownButton.childNodes[0].src = generikButtonCurrentMouseDownButton.notPressedButton;

	// callback to the client
	document.removeEventListener("mousemove", generikButtonMouseMoveHandler, true);
	document.removeEventListener("mouseup", generikButtonMouseUpHandler, true);	

	if (generikButtonCurrentMouseDownButton) {
		generikButtonCurrentMouseDownButton.removeEventListener("mouseover", generikButtonMouseOverHandler, true);
		generikButtonCurrentMouseDownButton.removeEventListener("mouseout", generikButtonMouseOutHandler, true);
	}
		
	event.stopPropagation();
	event.preventDefault();
		
	if (generikButtonCurrentMouseDownButton
	  && generikButtonCurrentMouseDownButton.generikButtonAction
	  && generikButtonCurrentMouseDownButton.generikButtonEnabled
	  && generikButtonCurrentMouseDownButton.generikButtonInside) {
		generikButtonCurrentMouseDownButton.generikButtonAction();
	}
	
	generikButtonCurrentMouseDownButton = null;
	
}

